/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
// Company       : 人о·Ƽ޹˾
//                 http://xiaomeige.taobao.com
// Web           : http://www.corecourse.cn
// 
// Create Date   : 2022/02/21 00:00:00
// Module Name   : ad1030_udp_gmii
// Description   : AD1030ݲɼ̫ϵͳ
// 
// Dependencies  : 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
/////////////////////////////////////////////////////////////////////////////////
`timescale 1ns / 1ps
module ad7606_udp_gmii(
    input clk_in1,
    input reset_n,
    
    //ACM7606Cģӿź
    output wire        ad7606_cs_n_o,         
    output wire        ad7606_rd_n_o,         
    input  wire        ad7606_busy_i,         
    input  wire [15:0] ad7606_db_i,           
    output wire [2:0]  ad7606_os_o,          
    output wire        ad7606_reset_o,        
    output wire        ad7606_convst_o,
    
    output wire        ad7606_cs_n_o2,         
    output wire        ad7606_rd_n_o2,         
    input  wire        ad7606_busy_i2,         
    input  wire [15:0] ad7606_db_i2,           
    output wire [2:0]  ad7606_os_o2,          
    output wire        ad7606_reset_o2,        
    output wire        ad7606_convst_o2,
    
      //eth_rx
    input         rgmii_rx_clk_i,
    input  [3:0]  rgmii_rxd,
    input         rgmii_rxdv,
    //eth_tx
    output        rgmii_tx_clk,
    output  [3:0] rgmii_txd,
    output        rgmii_txen,
    
    output        eth_rstn,  
    output        eth_mdc ,
    output        eth_mdio  
	 );

    //eth receive interface
    wire gmii_rx_clk; //̫ʱ
	  
    wire gmii_tx_clk;
    wire [7:0]gmii_txd;
    wire gmii_txen;
    wire [7:0] gmii_rxd;
    wire gmii_rxdv;
  
    //eth_rx
    wire [7:0]payload_dat_o;
    wire payload_valid_o;
    wire one_pkt_done;
    //pll
    wire clk50m;
    wire clk125m;
    wire udp_gmii_rst_n;
    wire pll_locked;
    //rxfifo    
    wire [7:0]rxdout;
    wire clk125m_o;
    wire rx_empty;
    wire fifo_rd_req;
    //rxcmd
    wire cmdvalid_0;
    wire [7:0]address_0;
    wire [31:0]cmd_data_0; 
  
    wire [7:0]ChannelSel;
    wire [31:0]DataNum;
    wire [31:0]ADC_Speed_Set;   
    wire RestartReq;
//    wire sample_en;
    
    wire [7:0]adc_data_flag;
    wire [15:0]adc_data_mult_ch;

    //txFIFO
    wire wr_en;
    wire [15:0]din;
    wire txempty;
    wire [7:0]dout;
    wire [14:0]rd_data_count;
    wire [13:0]wr_data_count;
    wire [15:0]fifowrdata_in;
    //txsend
    wire tx_en_pulse; 
    wire tx_done;
    wire test_en;           
    wire [15:0]lenth_val;
    
    //λ
    assign eth_rstn = 1;
    assign eth_mdc = 1;
    assign eth_mdio = 1;

    wire [7:0]fifo_wrdata;
    wire fifo_wrreq;
	 
    parameter local_mac = 48'h00_0a_35_01_fe_c0;
    parameter local_ip = 32'hc0_a8_00_02;
    parameter local_port = 16'd5000;

    wire rgmii_rx_clk;
    clk_wiz_0 pll   //໷λͬʱǿʱȳ
    (
        // Clock out ports
        .clk_out1(rgmii_rx_clk),     // output clk_out1
        .clk_in1(rgmii_rx_clk_i)      // input clk_in1
    );   

    wire Clk;
    clk_wiz_1 clk_wiz_1
    (
        // Clock out ports
        .clk_out1(Clk),     // output clk_out1
        // Clock in ports
        .clk_in1(clk_in1));      // input clk_in1

    rgmii_to_gmii rgmii_to_gmii(
        .reset(~reset_n),
        
        .rgmii_rx_clk(rgmii_rx_clk),
        .rgmii_rxd(rgmii_rxd),
        .rgmii_rxdv(rgmii_rxdv),
        
        .gmii_rx_clk(gmii_rx_clk),
        .gmii_rxdv(gmii_rxdv),
        .gmii_rxd(gmii_rxd),
        .gmii_rxer( )
    );
    
      //̫
    eth_udp_rx_gmii eth_udp_rx_gmii(
        .reset_p         (~reset_n               ),
        
        .local_mac       (local_mac             ),
        .local_ip        (local_ip              ),
        .local_port      (local_port            ),
        
        .clk125m_o       (clk125m_o               ),
        .exter_mac       (             ),
        .exter_ip        (              ),
        .exter_port      (            ),
        .rx_data_length  (        ),
        .data_overflow_i (         ),
        .payload_valid_o (payload_valid_o      ),
        .payload_dat_o   (payload_dat_o        ),
        
        .one_pkt_done    (one_pkt_done           ),
        .pkt_error       (            ),
        .debug_crc_check (                      ),
        
        .gmii_rx_clk     (gmii_rx_clk           ),
        .gmii_rxdv       (gmii_rxdv             ),
        .gmii_rxd        (gmii_rxd              )
    );
  
    wire [15:0]ad_out;
    wire ad_out_valid;

	 wire data;
    fifo_rx fifo_rx (    
        .rst(!reset_n), // input wire rst
        .wr_clk(clk125m_o), // input wire wr_clk
        .rd_clk(Clk), // input wire rd_clk
        .din(payload_dat_o), // input wire [7 : 0] din
        .wr_en(payload_valid_o), // input wire wr_en
        .rd_en(fifo_rd_req), // input wire rd_en
        .dout(rxdout), // output wire [7 : 0] dout
        .full(), // output wire full
        .empty(rx_empty) // output wire empty
		  );

    eth_cmd eth_cmd (
        .clk(Clk),
        .reset_n(reset_n),
        .fifo_rd_req(fifo_rd_req),
        .rx_empty(rx_empty),
        .fifodout(rxdout),
        .cmdvalid(cmdvalid_0),
        .address(address_0),
        .cmd_data(cmd_data_0)
        );
        
	 reg RestartReq_0_d0,RestartReq_0_d1;
	 reg [31:0]Number_d0,Number_d1;
	 
	 always@(posedge clk125m_o)
	 begin
		Number_d0 <= DataNum;
		Number_d1 <= Number_d0;
		
		RestartReq_0_d0 <= RestartReq;
		RestartReq_0_d1 <= RestartReq_0_d0;
	 end
		  
	cmd_rx cmd_rx_0(
		.clk(Clk),
		.reset_n(reset_n),
		.cmdvalid(cmdvalid_0),
		.cmd_addr(address_0),
		.cmd_data(cmd_data_0),
		
		.ChannelSel(ChannelSel),
		.DataNum(DataNum),
		.ADC_Speed_Set(ADC_Speed_Set),
		.RestartReq(RestartReq)
	);
///////////////////////////////////////////////////////////////////////////////////////////////////////////	

    reg ad_sample_en;
    reg [31:0]data_cnt;
    //߼ÿβźŵʼֹͣ
    always@(posedge Clk or negedge reset_n)
    if(!reset_n)
        ad_sample_en <= #1  1'b0;
    else if(RestartReq)
        ad_sample_en <= #1  1'b1;
    else if(data_cnt >= DataNum)
        ad_sample_en <= #1  1'b0;
    
    //ڲʹܽ׶ΣÿflagʱԼ1
    always@(posedge Clk or negedge reset_n)
        if(!reset_n)
            data_cnt <= #1  15'd0;
        else if(ad_sample_en) begin
            if(rd_en1 || rd_en2)
                data_cnt <= #1  data_cnt + 1'd1;
            else
                data_cnt <= #1  data_cnt;
        end else
            data_cnt <= #1  15'd0;
 

///////////////////////////////////////////////////////////////////////////////////////   
//ʹģݣΪͬźţʹFIFO洢ȻͳһȡFIFO
//FIFOĶʹܣֻҪFIFOͬʱգͿȶȡһͨݣȻȡͨ
// FIFOĶʹΪдFIFOдʹܣܽ潫ддFIFO
	//AD7606ģ
    ad7606C_driver ad7606C_driver1(
        .Clk(Clk),
        .Reset_n(reset_n),
        .Go(1),
        .Speed_Set(ADC_Speed_Set),
        .trig(),
        .convst_o(),
        .Conv_Done(),
        .ad7606_cs_n_o(ad7606_cs_n_o), 
        .ad7606_rd_n_o(ad7606_rd_n_o), 
        .ad7606_busy_i(ad7606_busy_i), 
        .ad7606_db_i(ad7606_db_i), 
        .ad7606_os_o(ad7606_os_o), 
        .ad7606_reset_o(ad7606_reset_o), 
        .ad7606_convst_o(ad7606_convst_o), 
		.data_flag(adc_data_flag),
		.data_mult_ch(adc_data_mult_ch)
    );	
    	
    /////////////////////////////////////////ΪģͬԴFIFOУڶȡʹ//////////
    wire empty1;
    wire full1;
    wire  rd_en1;
    wire [15:0] dout1;
    wire  wren_fifo1;
    assign wren_fifo1 = (adc_data_flag & ChannelSel)  && ad_sample_en;  //// дԵFIFO

    fifo_generator_0 fifo_generator_1 (
        .rst(!reset_n),        // input wire rst
        .wr_clk(Clk),  // input wire wr_clk
        .rd_clk(Clk),  // input wire rd_clk
        .din(adc_data_mult_ch),        // input wire [15 : 0] din
        .wr_en(wren_fifo1),    // input wire wr_en
        .rd_en(rd_en1),    // input wire rd_en
        .dout(dout1),      // output wire [15 : 0] dout
        .full(full1),      // output wire full
        .empty(empty1)    // output wire empty
    );    

    wire[7:0]adc_data_flag2;
	wire[15:0]adc_data_mult_ch2;
	//AD7606ģ
    ad7606C_driver ad7606C_driver2(    /// ģ
        .Clk(Clk),
        .Reset_n(reset_n),
        .Go(1),
        .Speed_Set(ADC_Speed_Set),
        .Conv_Done(),
        .ad7606_cs_n_o(ad7606_cs_n_o2), 
        .ad7606_rd_n_o(ad7606_rd_n_o2), 
        .ad7606_busy_i(ad7606_busy_i2), 
        .ad7606_db_i(ad7606_db_i2), 
        .ad7606_os_o(ad7606_os_o2), 
        .ad7606_reset_o(ad7606_reset_o2), 
        .ad7606_convst_o(ad7606_convst_o2), 
		.data_flag(adc_data_flag2),
		.data_mult_ch(adc_data_mult_ch2)
    );	
    
    wire empty2;
    wire full2;
    reg  rd_en2;
    wire [15:0] dout2;
    wire  wren_fifo2;
    assign wren_fifo2 = (adc_data_flag2 & ChannelSel)  && ad_sample_en;  //// дԵFIFO       
       
fifo_generator_0 fifo_generator_2 (
    .rst(!reset_n),        // input wire rst
    .wr_clk(Clk),  // input wire wr_clk
    .rd_clk(Clk),  // input wire rd_clk
    .din(adc_data_mult_ch2),        // input wire [15 : 0] din
    .wr_en(wren_fifo2),    // input wire wr_en
    .rd_en(rd_en2),    // input wire rd_en
    .dout(dout2),      // output wire [15 : 0] dout
    .full(full2),      // output wire full
    .empty(empty2)    // output wire empty
);      
   
    assign  rd_en1 = ((!empty2) && (!empty1));  //// FIFOֻҪվͿʼȡ
    always @(posedge Clk)                   ////  Ϊ˽д룬дһݣһĺд
        rd_en2 <= rd_en1;

    reg [15:0] s_ad_in3;
    always @(posedge Clk or negedge reset_n) ////  Ϊ˽д룬дһݣһĺд
        if (!reset_n)
            s_ad_in3 <= 16'd0;
        else if(rd_en1)
            s_ad_in3 <= dout1;
        else if (rd_en2)
            s_ad_in3 <= dout2;
        else 
            s_ad_in3 <= 16'd0;

    reg wrfifo_wren;
    always @(posedge Clk or negedge reset_n) // дFIFOдʹܣ                                             
        if (!reset_n)                       ///ҪдFIFOݡøFIFOĶʹܵΪдʹ
            wrfifo_wren <= 1'b0;
        else if(rd_en1 || rd_en2)
            wrfifo_wren <= 1'b1;
        else 
            wrfifo_wren <= 1'b0;         
//    assign wrfifo_wren = rd_en1 || rd_en2;    

///////////////////////////////////////////////////////////////////////////////////////////////////////
	
	wire	payload_req_o; 
    fifo_tx fifo_tx (
        .rst(!reset_n),        // input wire rst
        .wr_clk(Clk),  // input wire wr_clk
        .rd_clk(clk125m_o),  // input wire rd_clk
        .din({s_ad_in3[7:0],s_ad_in3[15:8]}),        // input wire [15 : 0] din
        .wr_en(wrfifo_wren),    // input wire wr_en
        .rd_en(payload_req_o),    // input wire rd_en
        .dout(dout),      // output wire [7 : 0] dout
        .full(),      // output wire full
        .empty(txempty),
        .rd_data_count(rd_data_count),  // output wire [14 : 0] rd_data_count
        .wr_data_count(wr_data_count)  // output wire [13 : 0] wr_data_count
    ); 
    
    //ʹܡݸƿ
    eth_send_ctrl eth_send_ctrl (
        .clk125M (clk125m_o),
        .reset_n(reset_n),
        .pkt_tx_done(tx_done),   
        .pkt_tx_en(tx_en_pulse),
        .eth_txfifo_rdusew(rd_data_count),
        .total_data_num(Number_d1),
        .restart_req(RestartReq_0_d1),
        .pkt_length(lenth_val)               
    );  
    
  eth_udp_tx_gmii eth_udp_tx_gmii
  (
    .clk125m       (clk125m_o               ),
    .reset_p       (~reset_n               ),

    .tx_en_pulse   (tx_en_pulse           ),
    .tx_done       (tx_done               ),

    .dst_mac       (48'hFF_FF_FF_FF_FF_FF            ),
    .src_mac       (48'h00_0a_35_01_fe_c0             ),  
    .dst_ip        (32'hc0_a8_00_03             ),
    .src_ip        (32'hc0_a8_00_02              ),  
    .dst_port      (16'd6102           ),
    .src_port      (16'd5000            ),

    .data_length   (lenth_val        ),
    
    .payload_req_o (payload_req_o        ),
    .payload_dat_i (dout        ),

    .gmii_tx_clk   (gmii_tx_clk                ),
    .gmii_txen     (gmii_txen             ),
    .gmii_txd      (gmii_txd              )
  );

 gmii_to_rgmii gmii_to_rgmii(
  .reset_n(reset_n),

  .gmii_tx_clk(gmii_tx_clk),
  .gmii_txd(gmii_txd),
  .gmii_txen(gmii_txen),
  .gmii_txer(1'b0),

  .rgmii_tx_clk(rgmii_tx_clk),
  .rgmii_txd(rgmii_txd),
  .rgmii_txen(rgmii_txen)
);
  
endmodule