
`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
module eth_send_ctrl(
    clk125M,
    reset_n,
    
    eth_txfifo_rdusew,
    total_data_num,       
    restart_req, 
	 
	pkt_tx_done,
    pkt_length,
    pkt_tx_en
); 
    input clk125M;
    input reset_n;

    input [14:0]eth_txfifo_rdusew;
    input [31:0]total_data_num;       
    input restart_req; 
	 
	input pkt_tx_done;
    output reg [15:0]pkt_length; 
    output reg pkt_tx_en;//ethͱ־ź

    reg [3:0]state;
    reg [31:0]data_num;
    reg [28:0]cnt_dly_time;

    parameter cnt_dly_min = 16'd128;
	 
	 //ADCΪ16λÿռ2ֽڣԷNݡҪ2*Nֽ

    //ɼֽ1500-IPͷ20ֽڣ-UDPͷ8ֽڣ= 1472ֽ
    always@(posedge clk125M or negedge reset_n)
    if(!reset_n)begin
        pkt_length <= 16'd0;
        data_num <= 32'd0;
        state <= 0;
		  pkt_tx_en <= 1'b0;
		  cnt_dly_time <= 28'd0;
    end
	else begin
        case(state)
            0:
                if(restart_req)begin
						data_num <= total_data_num;
						if((total_data_num << 1) >= 16'd1472)begin
							  pkt_length <= 16'd1472;	//һ2ֽ
							  state <= 1;
						 end
						 else if((total_data_num << 1) > 0)begin
						 pkt_length <= total_data_num << 1; //һ2ֽ
							state <= 1;
						 end
						 else begin
							state <= 0;
						 end
                end
				 
            1:
					if(eth_txfifo_rdusew >= (pkt_length -2))begin
						pkt_tx_en <= 1'b1;
						state <= 2;
					end
					else begin
						state <= 1;
						pkt_tx_en <= 1'b0;
					end
				
				2:
					begin
						pkt_tx_en <= 1'b0;
						if(pkt_tx_done)begin
							data_num <= data_num - pkt_length/2;
							state <= 3;
						end
					end						

	
				3:
				   if(cnt_dly_time >= cnt_dly_min)begin
                   state <= 4;
                   cnt_dly_time <= 28'd0;
               end
               else begin
                   cnt_dly_time <= cnt_dly_time + 1'b1;
						 state <= 3;
               end

				4:
               begin
						if(data_num * 2 >= 16'd1472)begin
							pkt_length <= 16'd1472;
							state <= 1;
						end
						else if(data_num * 2 > 0)begin
							pkt_length <= data_num * 2;
							state <= 1;
						end
						else begin
							state <= 0;
						end
               end 
     
            default:state <= 0;
        endcase
    end

endmodule
